/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ************************ ***********************************************************************************************
 *
 * $Id: TaxonVideoFactSheetController.java,v 20575c7536b3 2010/07/15 18:52:42 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.taxonomy.factsheet.video;

import javax.annotation.Nonnull;
import java.io.IOException;
import it.tidalwave.util.NotFoundException;
import it.tidalwave.util.logging.Logger;
import it.tidalwave.bluebill.taxonomy.Taxon;
import it.tidalwave.mobile.media.Movie;
import it.tidalwave.bluebill.mobile.taxonomy.factsheet.TaxonFactSheetControllerSupport;
import it.tidalwave.bluebill.mobile.taxonomy.factsheet.TaxonFactSheetUI;
import it.tidalwave.bluebill.factsheet.bbc.FactSheet;
import it.tidalwave.bluebill.mobile.taxonomy.factsheet.FactSheetProvider;
import it.tidalwave.bluebill.mobile.taxonomy.factsheet.VideoNode;
import it.tidalwave.mobile.media.Media;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public abstract class TaxonVideoFactSheetController extends TaxonFactSheetControllerSupport<TaxonFactSheetUI>
  {
    private static final String CLASS = TaxonVideoFactSheetController.class.getName();
    private static final Logger logger = Logger.getLogger(CLASS);

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public TaxonVideoFactSheetController (final @Nonnull TaxonFactSheetUI ui, 
                                          final @Nonnull Taxon taxon,
                                          final @Nonnull FactSheetProvider factSheetProvider)
      {
        super(ui, taxon, factSheetProvider);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public void initialize()
      {
        new Thread()
          {
            @Override
            public void run()
              {
                try
                  {
                    renderMovies(getFactSheet());
                  }
                catch (NotFoundException e)
                  {
                    e.printStackTrace();
//                    buffer.append("No fact sheet for this species");
                  }
                catch (IOException e)
                  {
                    e.printStackTrace();
//                    buffer.append("No fact sheet for this species");
                  }

                ui.notifyDataLoaded();
              }
          }.start();
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public DefaultAction<?> getDefaultAction (final @Nonnull Media media)
      {
        throw new UnsupportedOperationException("Not supported yet.");// FIXME: return a nullobject
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    private void renderMovies (final @Nonnull FactSheet factSheet)
      throws NotFoundException
      {
        for (final Movie movie : factSheet.get(FactSheet.MOVIES))
          {
            add(new VideoNode(movie));
          }
      }
  }
